<?php

/**
 * hist_titulo_etapa actions.
 *
 * @package    canon
 * @subpackage hist_titulo_etapa
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class hist_titulo_etapaActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'CA_TITULO_ETAPA_HIST',
        'CA_TITULO_ETAPA_MV'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'CA_TITULO_ETAPA_MV' =>
        array(
            'id_titulo_etapa' => 'CA_TITULO_ETAPA_HIST'
        )
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'CA_TITULO_ETAPA_MV' =>
        array(
            'id_titulo_etapa' => 'id_titulo_etapa',
            'id_titulo' => 'id_titulo',
            'id_etapa' => 'id_etapa',
            'id_novedad' => 'id_novedad',
            'fecha_inicio' => 'fecha_inicio',
            'fecha_fin' => 'fecha_fin',
            'fecha_inscripcion' => 'fecha_inscripcion',
            'anualidades' => 'anualidades',
            'estado' => 'estado',
            'actual' => 'actual',
            'nombre' => 'nombre_etapa'
        )
    ); //por cada tabla especificar los campos del select

    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'CA_TITULO_ETAPA_HIST' => array(
            'id_titulo_etapa,a' => array('!=' => array(-1)),
            'id_titulo_etapa,b' => array('=' => array('id_titulo_etapa')),
            'id_titulo' => array('=' => array('id_titulo')),
            'en_proceso' => array('=' => array(1)),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(); // filtros de condicion or
    protected $fields_orderBy = array(
        'id_titulo_etapa'
    ); //campos para el ordenamiento de la consulta
    protected $table_field_obligatory = array('id_titulo'); //campos obligatorios de filtro - estan en el request

    /*
     * Variables manejo de log
     */
    //true - consulta de administracion
//    protected $is_admin = true;
    //si es servicio para filtro agregar campo
    protected $filtro = 'Titulo';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;

    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_titulo_etapa'; //identificador de la tabla
    protected $id_names = array('id_titulo_etapa'); //llave primaria
    protected $field_names = array('id_titulo', 'id_etapa', 'id_novedad', 'fecha_inicio', 'fecha_fin',
        'fecha_inscripcion', 'anualidades', 'estado', 'actual'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'CA_TITULO_ETAPA'; //tabla en la cual se aplican los cambios
    protected $has_activo = true; //si posee campo en la tabla de nombre activo ---- ESTADO PARA REGALIAS - CARTERA
    protected $has_vigencia = false; //si posee vigencia
    protected $has_cen_op = false; //si posee centro de operacion
    protected $has_id_cia = false; //si posee compañia
    protected $has_secuencia = false; //si posee secuencia la tabla - true si es por tabla, false - trigger
    //   protected $check_exists = array('id_titulo_etapa');
//    protected $en_mayuscula = true; // si se pone, se puede poner en mayucula con true y en minuscula con false, de lo contrario la pone tal cual la BD

    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_titulo_etapa'; //identificador unico de la tabla
    //false - Registrar log para list - consultar
    protected $log_list = false;
    //false - Registrar log para add - update - remove
    protected $log_crud = false;

    /**
     * Construccion de observacion perzonalizada
     * 
     * Toda variable para tomarla del request con el formato:
     * &request-variable&
     * 
     * false - observacion por defecto
     *
     * @var string 
     */
    protected $observacion_list = false;
    protected $observacion_add = false;
    protected $observacion_update = false;
    protected $observacion_remove = false;

    // Validate

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Add
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateAdd(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */


        //Si es desde la funcionalidad de historicos validar que la primera etapa tenga como fecha de inicio la fecha de registro del titulo
        //Si es la segunda etapa validar que la fecha de inicio sea la fecha fin de la primera etapa mas un dia y que ademas exista la primera etapa
        //hardcoded id_etapa

        if (isset($request["hist"])) {
            $hist = $request["hist"];
        } else {
            $hist = 0;
        }


        if ($hist == 1) {

            $idTitulo = $request['id_titulo'];
            $fechaInicio = $request['fecha_inicio'];
            $etapa = $request["id_etapa"];
            if ($etapa == 1) {

                $sql = <<<EOD

select count(*) as count from rmn_titulo where id_titulo=$idTitulo and fecha_inscripcion_rmn=to_date('$fechaInicio', 'yyyy-mm-dd')

EOD;

                $records = CN_TABLE::executeSQL($sql, true);

                if ($records[0]['count'] == 0) {

                    $errors['mensaje'] = "La fecha de inicio de la primera etapa debe corresponder a la fecha de inscripción del título.";
                    $errors['servicio'] = "ca_titulo_etapa";
                }
                //} else if ($etapa == 2 || $etapa == 3) {
            } else if ($etapa >= 2) {
                //Nuevas etapa - 20180920
                //If de $etapa == 3 para que valide con la etapa de exploracion y no la de CONSTRUCCIÓN Y MONTAJE, pendiente verificar proceso completo - 20220103
                if ($etapa == 4) {
                    $etapa_ant = $etapa - 2;
                } else if ($etapa == 3) {
                    $etapa_ant = $etapa - 2;
                } else {
                    $etapa_ant = $etapa - 1;
                }

                $sql = <<<EOD
select count(*) as count 

from ca_titulo_etapa_hist hist 
join ca_titulo_etapa te on hist.id_titulo_etapa=te.id_titulo_etapa 
                        
where hist.id_titulo = $idTitulo and te.id_etapa = $etapa_ant
and hist.en_proceso = 1 
EOD;

                $records = CN_TABLE::executeSQL($sql, true);

                if ($records[0]['count'] == 0) {

                    if ($etapa == 2) {
                        $errors['mensaje'] = "Primero debe crearse la etapa de EXPLORACIÓN!";
                    } else {
                        //$errors['mensaje'] = "Primero debe crearse la etapa de CONSTRUCCIÓN Y MONTAJE!";
                        $errors['mensaje'] = "Primero debe crearse la etapa ANTERIOR!";
                    }
                    $errors['servicio'] = "ca_titulo_etapa";
                } else {

                    $sql = <<<EOD
select count(*) as count 

from ca_titulo_etapa_hist hist 
join ca_titulo_etapa te on hist.id_titulo_etapa=te.id_titulo_etapa 

where hist.id_titulo=$idTitulo and te.id_etapa=$etapa_ant
and hist.en_proceso = 1 

and case te.anualidades when 0 then te.fecha_fin else te.fecha_fin+1 end <=to_date('$fechaInicio', 'yyyy-mm-dd') 
EOD;

                    $records = CN_TABLE::executeSQL($sql, true);

                    if ($records[0]['count'] == 0) {

                        $errors['mensaje'] = "La fecha de inicio de esta etapa debe ser mayor que la fecha de terminación de la anterior etapa!";
                        $errors['servicio'] = "ca_titulo_etapa";
                    }
                }
            } else {
                $errors['mensaje'] = "Esa etapa no es valida. (Etapas validas: ER y CYM, EXPLORACION ADICIONAL)";
                $errors['servicio'] = "ca_titulo_etapa";
            }

            $sql = <<<EOD

select count(*) as count from ca_titulo_etapa_hist eh join ca_titulo_etapa te on eh.id_titulo_etapa=te.id_titulo_etapa 
where eh.id_titulo=$idTitulo and eh.en_proceso=1 and te.id_etapa=$etapa

EOD;

            $records = CN_TABLE::executeSQL($sql, true);

            if ($records[0]['count'] != 0) {

                $errors['mensaje'] = "Esa etapa ya ha sido creada!";
                $errors['servicio'] = "ca_titulo_etapa";
            }
        }


        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Update
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateUpdate(sfWebRequest $request) {

        //valor por defecto
        $errors = null;


        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Remove
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateRemove(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Acciones anteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function preprocessRequest($Action, sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");


        if (isset($request["hist"])) {
            $hist = $request["hist"];
        } else {
            $hist = 0;
        }

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            if ($request["id_etapa"] == 1 && $hist == 1 && $request["anualidades"] != 0) {
                $request["estado"] = 1;
            }
            $request["fecha_inscripcion"] = $request["fecha_inicio"];
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            $titEtap = $request["id_titulo_etapa"];

            $sql = <<<EOD

DELETE
FROM CA_TITULO_ETAPA_HIST
WHERE ID_TITULO_ETAPA =$titEtap

EOD;

            CN_TABLE::executeSQL($sql, true);
        }

        return $request;
    }

    /**
     * Acciones posteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function postprocessRequest($Action, sfWebRequest $request, $list_data_post) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {


            //REGISTRAR LA TITULO_ETAPA COMO UNA NUEVA PROYECCION EN CA_TITULO_ETAPA_HIST

            if (isset($request["hist"])) {
                $hist = $request["hist"];
            } else {
                $hist = 0;
            }

            if ($hist == 1) {

                $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
                $this->conn->beginTransaction();

                try {

                    $idTitulo = $request['id_titulo'];
                    $tituloEtapa = $list_data_post[0]['id_titulo_etapa'];
                    $fechaInicio = $request['fecha_inicio'];
                    $etapa = $request["id_etapa"];
                    $fecha = CN_TABLE::fechaSistema();
                    $observa = "Titulo Etapa generada desde el modificador de históricos";
                    if ($etapa == 1) {

                        $sql = <<<EOD

INSERT
INTO CA_TITULO_ETAPA_HIST
  (
    ID_TITULO,
    MUN_SEC,
    ID_TITULO_ETAPA,
    VIGENCIA,
    EN_PROCESO,
    FECHA_MOD,
    OBSERVACIONES
  )
select $idTitulo as id_titulo, nvl(max(mun_sec),0)+1 as mun_sec, $tituloEtapa as id_titulo_etapa, 
extract(year from to_date('$fechaInicio', 'yyyy-mm-dd')) as vigencia, 1, to_date('$fecha','yyyy-mm-dd'), 
'$observa' from ca_titulo_etapa_hist where id_titulo=$idTitulo

EOD;

                        CN_TABLE::executeSQL($sql, true);
                        //Nuevas etapa - 20180920    
                        //} elseif ($etapa == 2 || $etapa == 3) {
                    } elseif ($etapa >= 2) {

                        $sql = <<<EOD

INSERT
INTO CA_TITULO_ETAPA_HIST
  (
    ID_TITULO,
    MUN_SEC,
    ID_TITULO_ETAPA,
    VIGENCIA,
    EN_PROCESO,
    FECHA_MOD,
    OBSERVACIONES
  )
select id_titulo, mun_sec, $tituloEtapa as id_titulo_etapa, 
extract(year from to_date('$fechaInicio', 'yyyy-mm-dd')) as vigencia, 1, to_date('$fecha','yyyy-mm-dd'), 
'$observa' from ca_titulo_etapa_hist where id_titulo=$idTitulo and en_proceso=1 and rownum=1

EOD;
                        CN_TABLE::executeSQL($sql, true);
                    }

                    $this->conn->commit();
                } catch (Exception $e) {

                    $this->conn->rollback();
                }
            }
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

}
